#ifndef GENCLAUSE_H_OCT_15_2008
#define GENCLAUSE_H_OCT_15_2008

#include "array.h"

class GenClause
{
 public:
  GenClause() : preds_(NULL) {}
  GenClause(Array<int>** const& preds) : preds_(preds) {}
  ~GenClause() {}

  static void deleteGenClause(GenClause* const& genClause, const int& clauseLen)
  {
    Array<int>** preds = genClause->preds();
    for (int i = 0; i < clauseLen; i++)
      delete preds[i];
    delete [] preds;
    delete genClause;
  }

  Array<int>** preds() const                { return preds_; }
  void setPreds(Array<int>** const& preds)  { preds_ = preds; }

  //void appendClustCombIds(const Array<int>& idxs)   { clustCombIds_.append(idxs); }
  //void appendClustCombId(const int& idx)   { clustCombIds_.append(idx); }
  //const Array<int>& clustCombIds()         { return clustCombIds_; }

  void appendClauseReps(const Array<string>& clauseReps) {clauseReps_.append(clauseReps);}
  void appendClauseRep(const string& clauseRep) {clauseReps_.append(clauseRep);}
  Array<string>& clauseReps()                   { return clauseReps_; }

 private:
   Array<int>** preds_; //preds_[0]: array of predId and clustId
  //Array<int> clustCombIds_;
   Array<string> clauseReps_;
   //int clauseLen_;
};

#endif
