#ifndef HASHCLAUSE_H_OCT_08_2008
#define HASHCLAUSE_H_OCT_08_2008

#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;

class HashClause
{
 public:
  HashClause() {}

  size_t operator()(const int* const& clustIds) const
  {
    size_t hashCode = 1;
    for (int i = 0; i < size_; i++)
      hashCode = 31*hashCode + clustIds[i];
    return hashCode;
  }

  bool operator()(const int* const& clustIds1, const int*const& clustIds2) const
  {
    for (int i = 0; i < size_; i++)
      if (clustIds1[i] != clustIds2[i])
        return false;
    return true;
  }

  static void setSize(const int& size) { size_ = size; }

 private:
  static int size_;
};

typedef hash_set<const int*, HashClause, HashClause> ClauseSet;


#endif
