#ifndef HASHGENCLAUSE_H_OCT_15_2008
#define HASHGENCLAUSE_H_OCT_15_2008

#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#include "array.h"
#include "hasharray.h"
#include "genclause.h"

class HashGenClause
{
 public:
  HashGenClause() {}

  size_t operator()(GenClause* const& genClause) const
  {
    Array<int>** preds = genClause->preds();
    size_t hashCode = 1;
    for (int i = 0; i < size_; i++)
    {
      Array<int>& pred = *( preds[i] );
      for (int j = 0; j < pred.size(); j++)
        hashCode = 31*hashCode + pred[j];
    }
    return hashCode;
  }

  bool operator()(GenClause* const& genClause1, GenClause* const& genClause2) const
  {
    Array<int>** const& preds1 = genClause1->preds();
    Array<int>** const& preds2 = genClause2->preds();
    for (int i = 0; i < size_; i++)
    {
      Array<int>& pred1 = *( preds1[i] );
      Array<int>& pred2 = *( preds2[i] );
      if (pred1.size() != pred2.size()) return false;
      for (int j = 0; j < pred1.size(); j++)
        if (pred1[j] != pred2[j]) return false;
    }
    return true;
  }

  static void setSize(const int& size) { size_ = size; }

 private:
  static int size_;
};

typedef hash_set<GenClause*, HashGenClause, HashGenClause> GenClauseSet;
typedef HashArray<GenClause*, HashGenClause, HashGenClause> GenClauseHashArray;


#endif
