#ifndef RELCLUSTIDS_H_OCT_13_2008
#define RELCLUSTIDS_H_OCT_13_2008

#include <iostream>
using namespace std;

struct RelClustIds
{
  RelClustIds(const int& relId, const Array<int>& clustIds, const int& clustCombId)
    : relId_(relId), clustIds_(clustIds), clustCombId_(clustCombId), id_(-1) {}
  ~RelClustIds() {}

  void setLinkToIds(IntHashArray& ids)
  {
    linkToIds_.clear();
    linkToIds_.growToSize( ids.size() );
    for (int i = 0; i < ids.size(); i++)
      linkToIds_[i] = ids[i];
  }

  int relId_;
  Array<int> clustIds_;
  int clustCombId_; //id of clust comb in semnet
  int id_;
  Array<int> linkToIds_; //ids of other RelClustIds that this obj is linked to
};


class HashRelClustIds
{
 public:
  size_t operator()(RelClustIds* const& r) const
  {
    size_t hashCode = 31 + r->relId_;
    for (int i = 0; i < r->clustIds_.size(); i++)
      hashCode = 31*hashCode + r->clustIds_[i];
    return hashCode;
  }
};

class EqualRelClustIds
{
 public:
  bool operator()(RelClustIds* const& r1, RelClustIds* const& r2) const
  {
    if (r1->relId_ != r2->relId_) return false;
    for (int i = 0; i < r1->clustIds_.size(); i++)
      if (r1->clustIds_[i] != r2->clustIds_[i]) return false;
    return true;
  }
};

typedef hash_set<RelClustIds*, HashRelClustIds, EqualRelClustIds > RelClustIdsSet;
typedef HashArray<RelClustIds*, HashRelClustIds, EqualRelClustIds> RelClustIdsHashArray;

#endif
