#ifndef CLUSTERPAIR_H_OCT_07_2008
#define CLUSTERPAIR_H_OCT_07_2008

struct ClusterPair
{
  ClusterPair(const Cluster* const& clustA, const Cluster* const& clustB)
    : clustA_(clustA), clustB_(clustB), cnt_(0.0)  {}
  ~ClusterPair() {}

  const Cluster* clustA_;
  const Cluster* clustB_;
  double cnt_;
};


class ClusterPairComp
{
 public:
  static int compare(const ClusterPair* const& c0, const ClusterPair* const& c1)
  {
    if (c0->clustA_ < c1->clustA_) return -1;
    if (c0->clustA_ > c1->clustA_) return  1;
    //c0->clustA_ == c1->clustA_
    if (c0->clustB_ < c1->clustB_) return -1;
    if (c0->clustB_ > c1->clustB_) return  1;
    //c0->clustB_ == c1->clustB_
    return 0;
  }
};


typedef RBTree<ClusterPair*,ClusterPairComp> ClusterPairTree;
typedef ClusterPairTree::RBNode ClusterPairNode;


#endif
