#ifndef HASHTUPLE_H_OCT_08_2007
#define HASHTUPLE_H_OCT_08_2007

#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;

class HashTuple
{
 public:
  HashTuple() {}

  size_t operator()(const int* const& indexes) const
  {
    int hashCode = 1;
    for (int i = 0; i < size_; i++)
      hashCode = 31*hashCode + indexes[i];
    return hashCode;
  }

  bool operator()(const int* const& indexes1, const int* const& indexes2) const
  {
    for (int i = 0; i < size_; i++)
      if (indexes1[i] != indexes2[i])
        return false;
    return true;
  }

  static void setSize(const int& size) { size_ = size; }

 private:
  static int size_;
};

typedef hash_set<const int*, HashTuple, HashTuple> TupleSet;
typedef hash_map<const int*, double, HashTuple, HashTuple> TupleMap;


#endif
