#ifndef MOVE_H_OCT_07_2008
#define MOVE_H_OCT_07_2008

#include "intdouble.h"

enum { MOVE_NONE=0, MOVE_ONE=1, MOVE_SPLIT=2, MOVE_MERGE=3 };

struct Move
{
  Move() : move_(-1), typeId_(-1), clust0_(NULL), clust1_(NULL), llChange_(0.0) {}

  Move(const int& mv, const int& tid,
       Cluster* const& clus0, Cluster* const& clus1, const double& llch)
    : move_(mv), typeId_(tid), clust0_(clus0), clust1_(clus1), llChange_(llch){}

  int      move_;
  int      typeId_;
  Cluster* clust0_;
  Cluster* clust1_;
  double   llChange_;
};

///////////////////////////////////////////////////////////////////////////

class MoveComp
{
 public:
  static int compare(const Move* const& m0, const Move* const& m1)
  {
    assert(m0->move_   == m1->move_);
    assert(m0->typeId_ == m1->typeId_);

    if (m0->llChange_ > m1->llChange_) return -1; //sort in decreasing order
    if (m0->llChange_ < m1->llChange_) return  1;

    //llChange same

    Cluster* m0Clust0 = m0->clust0_, * m0Clust1 = m0->clust1_;
    Cluster* m1Clust0 = m1->clust0_, * m1Clust1 = m1->clust1_;

    Cluster* tmp = NULL;
    if (m0Clust0>m0Clust1) { tmp=m0Clust0; m0Clust0=m0Clust1; m0Clust1=tmp; }
    if (m1Clust0>m1Clust1) { tmp=m1Clust0; m1Clust0=m1Clust1; m1Clust1=tmp; }

    if (m0Clust0 == m1Clust0 && m0Clust1 == m1Clust1) return 0;
    if (m0Clust0 < m1Clust0) return -1;
    if (m0Clust0 > m1Clust0) return  1;
    //same clust0
    if (m0Clust1 < m1Clust1) return -1;
    if (m0Clust1 > m1Clust1) return  1;

    Util::assertt(false,"bad move comparison",-1);
    return 0;
  }
};

#endif
