#ifndef REL_H_OCT_03_2008
#define REL_H_OCT_03_2008

#include "array.h"

class Relation;

  //used by Type to store the relations it appears in
class Rel
{
 public:
  Rel() : relation_(NULL) {}
  Rel(Relation* relation) : relation_(relation) {}
  Rel(Relation* relation, const Array<int>& indexes)
    : relation_(relation), indexes_(indexes) {}
  ~Rel() {}

  void appendIndex(const int& i) { indexes_.append(i); }
  void compressIndexes()         { indexes_.compress(); }

  Relation* relation() const           { return relation_; }
  void setRelation(Relation* relation) { relation_ = relation; }

  const Array<int>& indexes() const { return indexes_; }
  int numIndexes() const            { return indexes_.size(); }
  int index(const int& idx) const   { return indexes_[idx]; }

  ostream& print(ostream& out) const;

 private:
  Relation* relation_; //not owned by object; do not delete
  Array<int> indexes_; //indexes of arguments with Type
};

inline
ostream& operator<<(ostream& out, const Rel& r) { return r.print(out); }

#endif
