#include "type.h"
#include "relation.h"

void Type::printRels(ostream& out) const
{
  for (int i = 0; i < rels_.size(); i++)
  {
    out << "type " << name_ << " appears in " << rels_[i]->relation()->name()
        << " at ";
    const Array<int>& indexes = rels_[i]->indexes();
    for (int j = 0; j < indexes.size(); j++)
      out << indexes[j] << " ";
    out << endl;
  }
}

void Type::setRepeatedInNaryRelation()
{
  repeatedInNaryRelation_ = false;
  for (int i = 0; i < rels_.size(); i++)
  {
    Relation* relation = rels_[i]->relation();
    const Array<int>& indexes = rels_[i]->indexes();
    if (indexes.size() >= 2 && relation->arity() > 2)
    {
      repeatedInNaryRelation_ = true;
      break;
    }
  }
}

void Type::setBinRelationsWithSameTypes()
{
  binRelationsWithSameTypes_.clear();
  for (int i = 0; i < rels_.size(); i++)
  {
    Relation* relation = rels_[i]->relation();
    const Array<int>& indexes = rels_[i]->indexes();
    if (indexes.size() == 2 && relation->arity() == 2)
      binRelationsWithSameTypes_.append(relation);
  }
}



