#ifndef CANDCLAUSE_H_OCT_21_2008
#define CANDCLAUSE_H_OCT_21_2008

class CandClause
{
 public:
  CandClause(const int& numDomains) { supportByDomain_.growToSize(numDomains); }
  ~CandClause() {}

  void addPred(const string& pred)   { preds_.append(pred); }
  const Array<string>& preds() const  { return preds_; }

  void addSupport(const int& dom, const string& support) 
  { supportByDomain_[dom].append(support); }

  void addSupport(const int& dom, const Array<string>& support) 
  {
    for (int i = 0; i < support.size(); i++)
      supportByDomain_[dom].append(support[i]); 
  }

  const Array<Array<string> >& supportByDomain() const
  { return supportByDomain_; }

  const Array<string>& supportByDomain(const int& domain) const
  { return supportByDomain_[domain]; }

 private:
  Array<string> preds_;
  Array<Array<string> > supportByDomain_; //comb of clustComb generating this candidate
};

class HashCandClause
{
 public:
  size_t operator()(CandClause* candClause) const
  {
    string str = "";
    const Array<string>& preds = candClause->preds();
    for (int i = 0; i < preds.size(); i++)
      str += " " + preds[i];
    return hash<char const *>()(str.c_str());
  }
};

class EqualCandClause
{
 public:
  bool operator()(CandClause* const& cc1, CandClause* const& cc2) const
  {
    const Array<string>& preds1 = cc1->preds();
    const Array<string>& preds2 = cc2->preds();
    if (preds1.size() != preds2.size()) return false;
    for (int i = 0; i < preds1.size(); i++)
      if (preds1[i].compare(preds2[i]) != 0) return false;
    return true;
  }
};

typedef hash_set<CandClause*, HashCandClause, EqualCandClause> CandClauseSet;

#endif
